package com.winsun.framework.zuul;

import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cloud.context.config.annotation.RefreshScope;
import org.springframework.cloud.netflix.eureka.EnableEurekaClient;
import org.springframework.cloud.netflix.zuul.EnableZuulProxy;
import org.springframework.context.annotation.Bean;
import org.springframework.web.cors.CorsConfiguration;
import org.springframework.web.cors.UrlBasedCorsConfigurationSource;
import org.springframework.web.filter.CorsFilter;

@SpringBootApplication
@EnableZuulProxy
@EnableEurekaClient
@RefreshScope
public class ZuulServiceApplication {

    @Bean
    public CorsFilter corsFilter() {
        final UrlBasedCorsConfigurationSource source = new UrlBasedCorsConfigurationSource();
        final CorsConfiguration config = new CorsConfiguration();
        config.setAllowCredentials(true); // 允许cookies跨域
        config.addAllowedOrigin("http://localhost:3000");
        config.addAllowedOrigin("https://dx.dianyuanjiangli.com");
        config.addAllowedOrigin("*ytx.21cn.com");
        config.addAllowedOrigin("*api.weixin.qq.com");
        config.addAllowedOrigin("*mp.weixin.qq.com");
        config.addAllowedOrigin("*open.weixin.qq.com");
        config.addAllowedOrigin("*mp.weixin.qq.com");
        config.addAllowedOrigin("*ismart.mini189.cn");
        config.addAllowedOrigin("*gzctpay.mini189.cn");
        config.addAllowedOrigin("*enter.gd189.cn");
        config.addAllowedOrigin("14.116.225.*");

        config.addAllowedHeader("*");// 允许访问的头信息,*表示全部
        config.setMaxAge(18000L);// 预检请求的缓存时间（秒），即在这个时间段里，对于相同的跨域请求不会再预检了
        config.addAllowedMethod("*");// 允许提交请求的方法，*表示全部允许，也可以单独设置GET、PUT等
        //c onfig.addAllowedMethod("HEAD");
        config.addAllowedMethod("GET");// 允许Get的请求方法
        // config.addAllowedMethod("PUT");
        config.addAllowedMethod("POST");
        // config.addAllowedMethod("DELETE");
        // config.addAllowedMethod("PATCH");
        source.registerCorsConfiguration("/**", config);
        return new CorsFilter(source);
    }

    public static void main(String[] args) {
        SpringApplication.run(ZuulServiceApplication.class, args);
    }
}
